#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"

#include "game/level_update.h"

#include "levels/scripts.h"


/* Fast64 begin persistent block [includes] */
/* Fast64 end persistent block [includes] */

#include "make_const_nonconst.h"
#include "levels/shystarvil/header.h"

/* Fast64 begin persistent block [scripts] */
/* Fast64 end persistent block [scripts] */

const LevelScript level_shystarvil_entry[] = {
	INIT_LEVEL(),
	LOAD_MIO0(0x7, _shystarvil_segment_7SegmentRomStart, _shystarvil_segment_7SegmentRomEnd), 
	LOAD_MIO0(0xa, _water_skybox_mio0SegmentRomStart, _water_skybox_mio0SegmentRomEnd), 
	ALLOC_LEVEL_POOL(),
	MARIO(MODEL_MARIO, 0x00000001, bhvMario),

	/* Fast64 begin persistent block [level commands] */
	/* Fast64 end persistent block [level commands] */

	AREA(1, shystarvil_area_1),
		WARP_NODE(0x0A, 124, 0x01, 0xF0, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF0, 1, 0x01, 0x32, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF1, 1, 0x01, 0x64, WARP_NO_CHECKPOINT),
		OBJECT(MODEL_1UP, 5477, -521, 3122, 0, 0, 0, 0x00000000, bhvRecoveryHeart),
		OBJECT(MODEL_NONE, 6177, -1050, 330, 0, -90, 0, 0x000A0000, bhvInstantActiveWarp),
		MARIO_POS(0x01, -90, 6177, -1050, 330),
		OBJECT(MODEL_1UP, 5114, -1386, -1526, 0, 0, 0, 0x00F00000, bhvWarpPipe),
		TERRAIN(shystarvil_area_1_collision),
		MACRO_OBJECTS(shystarvil_area_1_macro_objs),
		SET_BACKGROUND_MUSIC(0x00, SEQ_LEVEL_GRASS),
		TERRAIN_TYPE(TERRAIN_GRASS),
		/* Fast64 begin persistent block [area commands] */
		/* Fast64 end persistent block [area commands] */
	END_AREA(),

	FREE_LEVEL_POOL(),
	MARIO_POS(0x01, -90, 6177, -1050, 330),
	CALL(0, lvl_init_or_update),
	CALL_LOOP(1, lvl_init_or_update),
	CLEAR_LEVEL(),
	SLEEP_BEFORE_EXIT(1),
	EXIT(),
};
